
#include "TROOT.h"
#include "TFile.h"
#include "TTree.h"
#include "TCanvas.h"
#include "TH1F.h"
#include "TSystem.h"

#include "modules/RootManager/Data/include/CDataSample.hh"

static const Int_t kUPDATE = 1000;
static const Int_t N = 10000;

void read() 
{
   TFile *f = TFile::Open("root/run0000.root","READ");
   TTree *t; f->GetObject("Koyomi",t);

   CDataSample* data = 0;
   TBranch *bdata = 0;
   t->SetBranchAddress("branchname",&data,&bdata);

   TH1F *h = new TH1F("h","This is the CDataSample::vd distribution",100,-4,4);
   TCanvas *c = new TCanvas("c1","Dynamic Filling Example",200,10,700,500);

   for (Int_t i = 0; i < N; i++) {
      Long64_t tentry = t->LoadTree(i);
      bdata->GetEntry(tentry);
      
      std::vector<double>::iterator it = data->vd.begin();
      while(it != data->vd.end()){
	h->Fill(*it);
	++it;
      }

      if (i && (i%kUPDATE) == 0) {
         if (i == kUPDATE) h->Draw();
         c->Modified();
         c->Update();
         if (gSystem->ProcessEvents()) break;
      }
   }

   t->ResetBranchAddresses();
}


int test()
{
   read();

   return 0;
}
