#ifndef CROOTMANAGER_HH
#define CROOTMANAGER_HH

#include <string>
#include <vector>

#include "TTree.h"

class TFile;
class TBranch;

class CRootManager
{
public:
  CRootManager();
  ~CRootManager();

public:
  void Reset();
  TFile* CreateFile(std::string filename, std::string option = "");
  TTree* CreateTree(std::string treename, std::string title);
  template <class T>
  TBranch* CreateBranch(std::string branchname, T* obj, std::string treename = "");  
  void Fill();
  void Fill(std::string treename);
  void Write();
  void Write(std::string treename);
  TFile* GetFile();
  TTree* GetTree(std::string treename = "");

private:
  void DeleteFile();
  void DeleteTree();

private:
  std::vector<TTree*> tree_v;
  TFile* file;
};

template <class T>
inline TBranch* CRootManager::CreateBranch(std::string branchname, T* obj, std::string treename)  
{
  TTree* t = GetTree(treename);
  if(t){
    return t->Branch(branchname.c_str(), obj);
  }else{
    return 0;
  }
}



#endif
